2.6.35-22-virtual is missing nfs modules

Bug #659084 reported by Patrick G. on 2010-10-12
102
This bug affects 16 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Unassigned
Maverick
High
Tim Gardner
Natty
Medium
Unassigned

Bug Description

=== Update: nfs-common is already installed. ===

Binary package hint: linux-image-virtual

Mounting nfs shares is not possible.

mount.nfs: No such device
modprobe nfs - FATAL: Module nfs not found.

Linux nexus 2.6.35-22-virtual #33-Ubuntu SMP Sun Sep 19 23:54:13 UTC 2010 i686 GNU/Linux

the config file states that there should be modules compiled

---

grep NFS /boot/config-2.6.35-22-virtual
CONFIG_USB_FUNCTIONFS=m
CONFIG_USB_FUNCTIONFS_ETH=y
CONFIG_USB_FUNCTIONFS_RNDIS=y
CONFIG_USB_FUNCTIONFS_GENERIC=y
CONFIG_XENFS=m
CONFIG_XEN_COMPAT_XENFS=y
CONFIG_NFS_FS=m
CONFIG_NFS_V3=y
CONFIG_NFS_V3_ACL=y
CONFIG_NFS_V4=y
# CONFIG_NFS_V4_1 is not set
CONFIG_NFS_FSCACHE=y
CONFIG_NFSD=m
CONFIG_NFSD_V2_ACL=y
CONFIG_NFSD_V3=y
CONFIG_NFSD_V3_ACL=y
CONFIG_NFSD_V4=y
CONFIG_NFS_ACL_SUPPORT=m
CONFIG_NFS_COMMON=y
CONFIG_NCPFS_NFS_NS=y

--- directory is empty

/lib/modules/2.6.35-22-virtual/kernel/fs/nfs# ls -la
total 8
drwxr-xr-x 2 root root 4096 2010-09-20 04:46 .
drwxr-xr-x 54 root root 4096 2010-10-12 10:52 ..

---

http://packages.ubuntu.com/maverick/i386/linux-image-2.6.35-22-virtual/filelist
http://packages.ubuntu.com/maverick/amd64/linux-image-2.6.35-22-virtual/filelist

CVE References

Patrick G. (elgato) on 2010-10-12
description: updated
Haakon Nilsen (haakonn) wrote :

I just upgraded to 10.10 and got bit by this as well. This is a serious issue, please fix!

Ante Karamatić (ivoks) on 2010-10-12
Changed in linux-meta (Ubuntu):
status: New → Confirmed
Patrick G. (elgato) wrote :

Updated to linux-image-2.6.35-22-virtual 2.6.35-22.34
still missing nfs modules

Scott Moser (smoser) wrote :

@Haakon,
  Its only a work around, but you can quite likely just steal the needed modules from -server (or -generic-pae on i386), and put them into the appropriate place in the -virtual directory.

Changed in linux-meta (Ubuntu):
importance: Undecided → Medium
Haakon Nilsen (haakonn) wrote :

Good idea actually, but I can't get it to work. Copied the .ko-files for nfs, nfsd and nfs_common over from the -kernel deb, but they can't be loaded ("-1 Unknown symbol in module"). I don't want to risk further destabilisation, so I think I'll just wait it out. Thanks.

Scott Moser (smoser) wrote :

@Haakon,
I just did, on x86_64 (I assume i386 is the same):

# install the -server package
sudo apt-get install linux-server

# on x86_64 there is a '-server' kernel, on i386, it is '-generic-pae'
flav="server"
[ "$(uname -m)" = "x86_64" ] || flav="generic-pae"
sver=$(uname -r)
sver=${sver%-*} # remove '-virtual', sver will be like '2.6.35-22'

sdir=/lib/modules/${sver}-${flav}
tdir=/lib/modules/${sver}-virtual
module="nfs"

# parse modules.dep to get which modules $module depends on
mods=$(sed -n -e "\|/${module}.ko:|"'!'"d" -e 's,:,,p' "${sdir}/modules.dep")

for m in ${nfsmods}; do
   [ -f "${tdir}/${m}" ] && { echo "${m} already existed"; continue; }
   echo "${m} -> ${tdir}/${m%/*}"
   sudo mkdir -p "${tdir}/${m%/*}"

   sudo cp -a "${sdir}/${m}" "${tdir}/${m}"
done

sudo depmod -a

sudo modprobe nfs

Haakon Nilsen (haakonn) wrote :

Awesome, that worked, thanks! In my own attempts I forgot about the dependencies and the depmod thing.

For others following this recipe, replace ${nfsmods} with ${mods} (or vica versa).

Patrick G. (elgato) wrote :

@Scott

Thank you for this quick'n'dirty fix ;)
NFS seems to work.

-virtual is missing at least those modules:

kernel/fs/nfs/nfs.ko
kernel/fs/lockd/lockd.ko
kernel/fs/fscache/fscache.ko
kernel/fs/nfs_common/nfs_acl.ko
kernel/net/sunrpc/auth_gss/auth_rpcgss.ko
kernel/net/sunrpc/sunrpc.ko

Hope to see a fix soon.

The Loeki (the-loeki) wrote :

Got hit by #570542 at the same time.
The two issues seem to have some similarities between them in that they're both broken kernel modules in the -virtual that should've been available and seem to have been compiled in, or the build at least should've tried.

I've noticed that the -headers packages contain the same files overall, but the -image-virtual packages are missing both libahci.ko and the aforementioned .ko's.

Scott Moser (smoser) on 2010-11-03
tags: added: ec2-images uec-images
Jacob Strauss (jacob-strauss) wrote :

As an alternative workaround, the attached patch makes rebuilding the -virtual package from source include the right modules for nfs clients. I don't know that this includes all the missing modules, or is really the right place to fix however.

Tim Gardner (timg-tpi) on 2010-11-15
affects: linux-meta (Ubuntu) → linux (Ubuntu)
Tim Gardner (timg-tpi) on 2010-11-15
Changed in linux (Ubuntu Maverick):
assignee: nobody → Tim Gardner (timg-tpi)
importance: Undecided → High
milestone: none → maverick-updates
status: New → In Progress
tags: added: patch
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.37-5.13

---------------
linux (2.6.37-5.13) natty; urgency=low

  [ Andy Whitcroft ]

  * rebased to v2.6.37-rc2
  * updateconfigs following rebase to v2.6.37-rc2

  [ Tim Gardner ]

  * [Config] Added NFS and related modules to virtual flavour
    - LP: #659084

  [ Upstream Kernel Changes ]

  * x86, cpu: Rename verify_cpu_64.S to verify_cpu.S
  * x86, cpu: Clear XD_DISABLED flag on Intel to regain NX
  * x86, cpu: Call verify_cpu during 32bit CPU startup
  * x86, cpu: Only CPU features determine NX capabilities

  [ Upstream Changes ]

  * rebased to v2.67.37-rc2
 -- Andy Whitcroft <email address hidden> Tue, 16 Nov 2010 13:13:29 +0000

Changed in linux (Ubuntu):
status: Confirmed → Fix Released
Tim Gardner (timg-tpi) on 2010-11-17
Changed in linux (Ubuntu Maverick):
status: In Progress → Fix Committed
Nico Brys (nico-brys) wrote :

any idea when this will be released?

Accepted linux into maverick-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

tags: added: verification-needed
Tim Gardner (timg-tpi) wrote :

Verified:

$ wget http://archive.ubuntu.com/ubuntu/pool/main/l/linux/linux-image-2.6.35-24-virtual_2.6.35-24.42_amd64.deb
--2010-12-07 18:55:46-- http://archive.ubuntu.com/ubuntu/pool/main/l/linux/linux-image-2.6.35-24-virtual_2.6.35-24.42_amd64.deb
Resolving archive.ubuntu.com... 91.189.88.31, 91.189.88.40, 91.189.88.45, ...
Connecting to archive.ubuntu.com|91.189.88.31|:80... connected.
HTTP request sent, awaiting response... 200 OK
Length: 10647450 (10M) [application/x-debian-package]
Saving to: `linux-image-2.6.35-24-virtual_2.6.35-24.42_amd64.deb'

100%[=============================================================================>] 10,647,450 8.15M/s in 1.2s

2010-12-07 18:55:48 (8.15 MB/s) - `linux-image-2.6.35-24-virtual_2.6.35-24.42_amd64.deb' saved [10647450/10647450]

$ mkdir junk
$ dpkg -x linux-image-2.6.35-24-virtual_2.6.35-24.42_amd64.deb junk
$ find junk|egrep "nfs|lockd|fscache|auth|sunrpc"
junk/lib/modules/2.6.35-24-virtual/kernel/drivers/xen/xenfs
junk/lib/modules/2.6.35-24-virtual/kernel/drivers/xen/xenfs/xenfs.ko
junk/lib/modules/2.6.35-24-virtual/kernel/fs/nfsd
junk/lib/modules/2.6.35-24-virtual/kernel/fs/lockd
junk/lib/modules/2.6.35-24-virtual/kernel/fs/lockd/lockd.ko
junk/lib/modules/2.6.35-24-virtual/kernel/fs/fscache
junk/lib/modules/2.6.35-24-virtual/kernel/fs/fscache/fscache.ko
junk/lib/modules/2.6.35-24-virtual/kernel/fs/nfs_common
junk/lib/modules/2.6.35-24-virtual/kernel/fs/nfs_common/nfs_acl.ko
junk/lib/modules/2.6.35-24-virtual/kernel/fs/nfs
junk/lib/modules/2.6.35-24-virtual/kernel/fs/nfs/nfs.ko
junk/lib/modules/2.6.35-24-virtual/kernel/crypto/authenc.ko
junk/lib/modules/2.6.35-24-virtual/kernel/net/sunrpc
junk/lib/modules/2.6.35-24-virtual/kernel/net/sunrpc/xprtrdma
junk/lib/modules/2.6.35-24-virtual/kernel/net/sunrpc/sunrpc.ko
junk/lib/modules/2.6.35-24-virtual/kernel/net/sunrpc/auth_gss
junk/lib/modules/2.6.35-24-virtual/kernel/net/sunrpc/auth_gss/auth_rpcgss.ko

tags: added: verification-done
removed: verification-needed
Daniel Harvey (daniel.harvey) wrote :

Verified by me also. NFS works.

cjp (cjp618) wrote :

nfsd.ko is still missing though -- so no NFS serving.

Scott Moser (smoser) wrote :

This bug also affects natty -virtual at the moment:

% dpkg -S /boot/vmlinuz-2.6.37-8-virtual
linux-image-2.6.37-8-virtual: /boot/vmlinuz-2.6.37-8-virtual
% cd /lib/modules/2.6.37-8-virtual/
% find * -type f | egrep "nfs|lockd|fscache|auth|sunrpc"
kernel/crypto/authenc.ko
kernel/fs/lockd/lockd.ko
kernel/fs/nfs_common/nfs_acl.ko
kernel/fs/fscache/fscache.ko
kernel/fs/nfs/nfs.ko
kernel/drivers/xen/xenfs/xenfs.ko
kernel/net/sunrpc/sunrpc.ko
kernel/net/sunrpc/auth_gss/auth_rpcgss.ko

Launchpad Janitor (janitor) wrote :
Download full text (9.0 KiB)

This bug was fixed in the package linux - 2.6.35-24.42

---------------
linux (2.6.35-24.42) maverick-proposed; urgency=low

  [ Brad Figg ]

  - LP: #683422

  [ Colin Ian King ]

  * SAUCE: Allow registration of handler to multiple WMI events with same
    GUID
    - LP: #676997
  * SAUCE: Add WMI hotkeys support for Dell All-In-One series
    - LP: #676997
  * [Config] Enable Dell All-In-One WMI Hotkeys driver
    - LP: #676997

  [ David Woodhouse ]

  * [Upstream] Call acpi_video_register() in intel_opregion_init() failure
    path
    - LP: #615947

  [ Manoj Iyer ]

  * SAUCE: enable rfkill for rtl8192se driver
    - LP: #640992
  * SAUCE: Enable jack sense for Thinkpad Edge 11
    - LP: #677210

  [ Tim Gardner ]

  * [Config] Use correct be2iscsi module name in d-i/modules/scsi-modules
    - LP: #628776
  * [Config] Added NFS and related modules to virtual flavour
    - LP: #659084
  * [Config] Add support for cross compiling armel
  * Simplify the use of CROSS_COMPILER

  [ Upstream Kernel Changes ]

  * Revert "(pre-stable) ACPI: enable repeated PCIEXP wakeup by clearing
    PCIEXP_WAKE_STS on resume"
  * Revert "(pre-stable) mm: Move vma_stack_continue into mm.h"
  * x86, cpu: After uncapping CPUID, re-run CPU feature detection
    - LP: #672664
  * ALSA: sound/pci/rme9652: prevent reading uninitialized stack memory
    - LP: #672664
  * ALSA: oxygen: fix analog capture on Claro halo cards
    - LP: #672664
  * ALSA: hda - Add Dell Latitude E6400 model quirk
    - LP: #643891, #672664
  * ALSA: prevent heap corruption in snd_ctl_new()
    - LP: #672664
  * ALSA: rawmidi: fix oops (use after free) when unloading a driver module
    - LP: #672664
  * hwmon: (lis3) Fix Oops with NULL platform data
    - LP: #672664
  * USB: fix bug in initialization of interface minor numbers
    - LP: #672664
  * usb: musb: gadget: fix kernel panic if using out ep with FIFO_TXRX
    style
    - LP: #672664
  * usb: musb: gadget: restart request on clearing endpoint halt
    - LP: #672664
  * HID: hidraw, fix a NULL pointer dereference in hidraw_ioctl
    - LP: #672664
  * HID: hidraw, fix a NULL pointer dereference in hidraw_write
    - LP: #672664
  * ahci: fix module refcount breakage introduced by libahci split
    - LP: #672664
  * lib/list_sort: do not pass bad pointers to cmp callback
    - LP: #672664
  * ACPI: invoke DSDT corruption workaround on all Toshiba Satellite
    - LP: #672664
  * oprofile: Add Support for Intel CPU Family 6 / Model 29
    - LP: #672664
  * oprofile, ARM: Release resources on failure
    - LP: #672664
  * RDMA/cxgb3: Turn off RX coalescing for iWARP connections
    - LP: #672664
  * drm/radeon/kms: fix bad cast/shift in evergreen.c
    - LP: #672664
  * drm/radeon/kms: avivo cursor workaround applies to evergreen as well
    - LP: #672664
  * ARM: 6400/1: at91: fix arch_gettimeoffset fallout
    - LP: #672664
  * ARM: 6395/1: VExpress: Set bit 22 in the PL310 (cache controller)
    AuxCtlr register
    - LP: #672664
  * V4L/DVB: gspca - main: Fix a crash of some webcams on ARM arch
    - LP: #672664
  * V4L/DVB: gspca - sn9c20x: Bad transfer size of Bayer images
    - LP: #672664
  * mmc: sdhci-s3c: fix NULL ptr acc...

Read more...

Changed in linux (Ubuntu Maverick):
status: Fix Committed → Fix Released

Hi,

Tried using Scott Moser's workaround but I keep getting

sed: can't read /lib/modules/2.6.35-22-generic-pae/modules.dep: No such file or directory.

I believe this is due to the difference in file name between the 2.6.35-22-generic-pae in the script and version 2.6.35-28-generic-pae that gets downloaded when running sudo apt-get install linux-server

Sure enough, when I check /lib/modules, I see the following:
2.6.35-22-virtual
2.6.35-28-generic-pae

Thanks,
JJJ

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers